/**********************************************************************
 *
 * This program is to test the number of entries extension for vgroup
 *
 * author cirio@crs4.it
 * date   18.03.93
 *
 **********************************************************************/

/* 
 * $Id: tvextended.c,v 2.0 1993/06/18 16:41:55 cirio Exp $
 *
 * $Header: /u/cirio/NCSA/HDF/HDF3.2r4.extended/test/RCS/tvextended.c,v 2.0 1993/06/18 16:41:55 cirio Exp $
 *
 * $Revision: 2.0 $
 *
 * $Log: tvextended.c,v $
 * Revision 2.0  1993/06/18  16:41:55  cirio
 * Ported on SUN
 *
 * Revision 1.2  1993/06/03  14:21:02  cirio
 * Added "#ifdef PROTOTYPE" for SUN compatibility
 *
 * Revision 1.1  1993/03/18  14:59:24  cirio
 * Initial revision
 *
 *
 */

#include "vg.h"

#ifdef PROTOTYPE
main(int ac, char **av) 
#else
main(ac, av)
     int ac;
     char **av;
#endif

{

#define FILENAME "tvextended.hdf"
#define VGROUPNUM MAXNVELT+1
#define VDATANUM  MAXNVELT+1

  int32 f;
  VGROUP *vgroot, *vg;
  VDATA  *vd;
  int32 vgrootid,vgid, id;
  int found;
  int32 nentries;
  int i,j;
  char name[20];
  int32 databuffer=100;


  if( FAIL==(f=Vopen(FILENAME,DFACC_ALL,0))) {
    fprintf(stderr, "open err %s\n",FILENAME);
    exit(1);
  }
  vgroot = (VGROUP*) Vattach(f,-1,"w");
  Vsetname(vgroot, "vgroot");

  for(i=0;i<VGROUPNUM;i++) {
    vg = (VGROUP*) Vattach(f,-1,"w");
    sprintf(name,"vgroup #%d",i);
    Vsetname(vg, name);
    Vinsert(vgroot, (VDATA*)vg);
    fprintf(stderr, "creating VGROUP #%d \n",i);
    fprintf(stderr, "Inserting vdata");
    for(j=0;j<VDATANUM;j++) {
      vd = (VDATA*) VSattach(f,-1,"w");
      sprintf(name,"vdata #%d.%d",i,j);
      VSsetname(vd, name);
      VSsetfields( vd, "IX");
      VSsetinterlace(vd, NO_INTERLACE);
      VSwrite(vd, (unsigned char *)(&databuffer), 1, NO_INTERLACE); 
      Vinsert(vg, vd);
      VSdetach(vd);
      fprintf(stderr, " %d", j);
    }
    fprintf(stderr, "\n");
    Vdetach(vg);
  }

  Vdetach(vgroot);

  Vclose(f);

  if( FAIL==(f=Vopen(FILENAME,DFACC_RDONLY,0))) {
    fprintf(stderr, "open err %s\n",FILENAME);
    exit(1);
  }
  
  found = 0;
  vgrootid = -1 ;

  while ( (vgrootid = Vgetid(f, vgrootid)) != -1 ) {
    vgroot = (VGROUP *) Vattach(f, vgrootid, "r");
    Vinquire(vgroot, &nentries, name);
    if (strcmp(name, "vgroot") == 0) {
      found = 1;
      break;
    } 
    else {
      Vdetach(vgroot);
    }
  }

  if ( found == 0) {
    fprintf(stderr, "Cannot find vgroup 'vgroot'\n");
    exit(1);
  }

  fprintf(stderr, "Found vgroup 'vgroot' with %d entries\n", nentries);
  if (nentries != VGROUPNUM) {
    fprintf(stderr, "Wrong number of entries in vgroup 'vgroot'\n");
    exit(1);
  }

  vgid = -1;

  while ( (vgid = Vgetnext(vgroot, vgid)) != -1 ) {
    if (Visvg(vgroot, vgid)) {
      vg = (VGROUP *) Vattach(f, vgid, "r");
      Vinquire(vg, &nentries, name);
      fprintf(stderr, "Found vgroup '%s' with %d entries\n", name, nentries);
      if (nentries != VDATANUM) {
	fprintf(stderr, "Wrong number of entries in vgroup %s\n", name);
	exit(1);
      }
      Vdetach(vg);
    }
  }
  
  Vdetach(vgroot);

  Vclose(f);

  fprintf(stderr, "TVEXTENDED TEST SUCCESSFULLY COMPLETED\n");

}




